Menu

- Learn
- Documentation
  - Language Reference
  - Library Reference
  - Command-line Reference
  - Feature Overview
  - Articles
- Downloads
- Packages
- Community
  - Blog
  - Orgs using D
  - Twitter
  - Calendar
  - Forums
  - IRC
  - Community Discord
  - Wiki
  - GitHub
  - Issues
  - Get involved
  - Contributors
  - Foundation
  - Security Team
  - Donate
  - Sponsors
- Resources
  - Tour
  - Books
  - Tutorials
  - Tools
  - Editors
  - IDEs
  - run.dlang.io
  - Visual D
  - Acknowledgments
  - D Style
  - Glossary
  - Sitemap

Search
Report a bug
If you spot a problem with this page, click here to create a Bugzilla issue.
Improve this page
Quickly fork, edit online, and submit a pull request for this page. Requires a signed-in GitHub account. This works well for small changes. If you'd like to make larger changes you may want to consider using a local clone.

# DMD Compiler for OSX

- Requirements and Downloads
- Installation
- Compiler Arguments and Switches
- Files
- Linking
- Environment Variables
- dmd.conf Initialization File
- Differences between Windows and Linux versions
- D Interface Files
- Building Libraries
- Compiling dmd
- Compiling Phobos

## Requirements and Downloads

1. DMD Compiler
2. Mac OS X Mavericks (10.9) or later
3. Xcode

## Installation

Hint - The official packages performs these steps automatically. Alternatively, you can install DMD in your user directory with the install script.

- Put the dmd zip file into your home directory, and unzip it:

      unzip dmd.VERSION.zip

  where VERSION is the particular version of the zip file.
- It will create a ~/dmd2 directory with all the files in it. All the tools are command line tools, which means they are run from a console window.
- Verify that this works by creating hello.d in your home directory with these contents:

      import std.stdio;

      void main()
      {
          writeln("hello world!");
      }

  and compile and run it with:

      dmd2/osx/bin/dmd hello
      ./hello

  and it should print:

      hello world!

- To install a global copy:
- Copy binaries to /usr/local/bin:

      sudo cp dmd2/osx/bin/{dmd,dumpobj,obj2asm,rdmd,dub,ddemangle,dustmite} /usr/local/bin
      sudo cp dmd2/osx/bin/dmdx.conf /usr/local/bin/dmd.conf

- Copy the library to /usr/local/lib:

      sudo cp dmd2/osx/lib/libphobos2.a /usr/local/lib

- Copy the standard library and runtime sources to /usr/local/include/d/dmd:

      sudo mkdir -p /usr/include/d/dmd
      sudo cp dmd2/{phobos/std,phobos/etc,druntime/import} /usr/include/d/dmd

## Compiler Arguments and Switches

dmd files... -switches...
files...

  File Extensions
  Extension | File Type
  --- | ---
  none | D source files
  .d | D source files
  .dd | Ddoc source files
  .di | D interface files
  .o | Object files to link in
  .a | Object code libraries to search

@cmdfile
  If cmdfile is an environment variable, read the compiler arguments and switches from the value of that variable. Otherwise, read compiler arguments and switches from the text file cmdfile. The file may contain single-line comments starting with the hash symbol (#).
-allinst
  Generate code for all template instantiations
-betterC
  Adjusts the compiler to implement D as a better C:
  - Predefines D_BetterC version.
  - Assert Expressions, when they fail, call the C runtime library assert failure function rather than a function in the D runtime.
  - Array overflows call the C runtime library assert failure function rather than a function in the D runtime.
  - Final switch errors call the C runtime library assert failure function rather than a function in the D runtime.
  - Does not automatically link with phobos runtime library.
  - Does not generate Dwarf eh_frame with full unwinding information, i.e. exception tables are not inserted into eh_frame.
  - Module constructors and destructors are not generated meaning that static and shared static constructors and destructors will not get called.
  - ModuleInfo is not generated.
  - TypeInfo instances will not be generated for structs.
-boundscheck=[on|safeonly|off ]
  Controls if bounds checking is enabled.
  - on: Bounds checks are enabled for all code. This is the default.
  - safeonly: Bounds checks are enabled only in @safe code. This is the default for -release builds.
  - off: Bounds checks are disabled completely (even in @safe code). This option should be used with caution and as a last resort to improve performance. Confirm turning off @safe bounds checks is worthwhile by benchmarking.
-c
  Compile only, do not link
-check=[assert|bounds|in|invariant|out|switch ][=[on|off]]
  Overrides default, -boundscheck, -release and -unittest options to enable or disable specific checks.
  - assert: assertion checking
  - bounds: array bounds
  - in: in contracts
  - invariant: class/struct invariants
  - out: out contracts
  - switch: finalswitch failure checking
  - on or not specified: specified check is enabled.
  - off: specified check is disabled.
-check=[h|help|? ]
  List information on all available checks
-checkaction=[D|C|halt|context ]
  Sets behavior when an assert fails, and array boundscheck fails, or a final switch errors.
  - D: Default behavior, which throws an unrecoverable AssertError.
  - C: Calls the C runtime library assert failure function.
  - halt: Executes a halt instruction, terminating the program.
  - context: Prints the error context as part of the unrecoverable AssertError.
-checkaction=[h|help|? ]
  List information on all available check actions
-color
  Turn colored console output on
-color=[on|off|auto ]
  Show colored console output. The default depends on terminal capabilities.
  - auto: use colored output if a tty is detected (default)
  - on: always use colored output.
  - off: never use colored output.
-conf=filename
  Use config file at filename
-cov
  Do code coverage analysis
-cov=nnn
  Perform code coverage analysis and generate .lst file with report.

    dmd -cov -unittest myprog.d

-D

  Generate documentation from source.

  Note: mind the security considerations.

-Dd directory
  Write documentation file to directory . -op can be used if the original package hierarchy should be retained
-Df filename
  Write documentation file to filename
-d
  Silently allow deprecated features and use of symbols with deprecated attributes.
-de
  Issue an error when deprecated features or symbols are used (halt compilation)
-dw
  Issue a message when deprecated features or symbols are used (default)
-debug
  Compile in debug code
-debug=level
  Compile in debug level <= level
-debug=ident
  Compile in debug identifier ident
-debuglib=name
  Link in libname as the default library when compiling for symbolic debugging instead of libphobos2.a. If libname is not supplied, then no default library is linked in.
-defaultlib=name
  Link in libname as the default library when not compiling for symbolic debugging instead of libphobos2.a. If libname is not supplied, then no default library is linked in.
-deps
  Print module dependencies (imports/file/version/debug/lib)
-deps=filename
  Without filename, print module dependencies (imports/file/version/debug/lib). With filename, write module dependencies as text to filename (only imports).
-extern-std=standard
  Standards supported are:
  - c++98 (default): Use C++98 name mangling, Sets __traits(getTargetInfo, "cppStd") to 199711
  - c++11: Use C++11 name mangling, Sets __traits(getTargetInfo, "cppStd") to 201103
  - c++14: Use C++14 name mangling, Sets __traits(getTargetInfo, "cppStd") to 201402
  - c++17: Use C++17 name mangling, Sets __traits(getTargetInfo, "cppStd") to 201703
-extern-std=[h|help|? ]
  List all supported standards
-fPIC
  Generate position independent code
-g
  Add symbolic debug info in Dwarf format for debuggers such as gdb
-gf
  Symbolic debug info is emitted for all types referenced by the compiled code, even if the definition is in an imported file not currently being compiled.
-gs
  Always emit stack frame
-gx
  Adds stack stomp code, which overwrites the stack frame memory upon function exit.
-H
  Generate D interface file
-Hd=directory
  Write D interface file to dir directory. -op can be used if the original package hierarchy should be retained.
-Hf=filename
  Write 'header' file to filename
-HC
  Generate C++ 'header' file
-HCd=directory
  Write C++ 'header' file to directory
-HCf=filename
  Write C++ 'header' file to filename
--help
  Print help and exit
-I=directory
  Look for imports also in directory
-i[=pattern ]

  Enables "include imports" mode, where the compiler will include imported modules in the compilation, as if they were given on the command line. By default, when this option is enabled, all imported modules are included except those in druntime/phobos. This behavior can be overriden by providing patterns via -i=<pattern>. A pattern of the form -i=<package> is an "inclusive pattern", whereas a pattern of the form -i=-<package> is an "exclusive pattern". Inclusive patterns will include all module's whose names match the pattern, whereas exclusive patterns will exclude them. For example. all modules in the package foo.bar can be included using -i=foo.bar or excluded using -i=-foo.bar. Note that each component of the fully qualified name must match the pattern completely, so the pattern foo.bar would not match a module named foo.barx.

  The default behavior of excluding druntime/phobos is accomplished by internally adding a set of standard exclusions, namely, -i=-std -i=-core -i=-etc -i=-object. Note that these can be overriden with -i=std -i=core -i=etc -i=object.

  When a module matches multiple patterns, matches are prioritized by their component length, where a match with more components takes priority (i.e. pattern foo.bar.baz has priority over foo.bar).

  By default modules that don't match any pattern will be included. However, if at least one inclusive pattern is given, then modules not matching any pattern will be excluded. This behavior can be overriden by usig -i=. to include by default or -i=-. to exclude by default.

  Note that multiple -i=... options are allowed, each one adds a pattern.

-ignore
  Ignore unsupported pragmas
-inline
  Inline functions at the discretion of the compiler. This can improve performance, at the expense of making it more difficult to use a debugger on it.
-J=directory
  Where to look for files for ImportExpressions. This switch is required in order to use ImportExpressions. path is a ; separated list of paths. Multiple -J's can be used, and the paths are searched in the same order.
-L=linkerflag
  Pass linkerflag to the linker, for example, ld
-lib
  Generate library file as output instead of object file(s). All compiled source files, as well as object files and library files specified on the command line, are inserted into the output library. Compiled source modules may be partitioned into several object modules to improve granularity. The name of the library is taken from the name of the first source module to be compiled. This name can be overridden with the -of switch.
-lowmem
  Enable the garbage collector for the compiler, reducing the compiler memory requirements but increasing compile times.
-m32
  Compile a 32 bit executable. This is the default for the 32 bit dmd. .
-m64
  Compile a 64 bit executable. This is the default for the 64 bit dmd.
-main
  Add a default main() function when compiling. This is useful when unittesting a library, as it enables running the unittests in a library without having to manually define an entry-point function.
-man
  Open browser specified by the BROWSER environment variable on this page. If BROWSER is undefined, Safari is assumed.
-map
  Generate a .map file
-mcpu=id
  Set the target architecture for code generation, where:
  help
    list alternatives
  baseline
    the minimum architecture for the target platform (default)
  avx
    generate AVX instructions instead of SSE instructions for vector and floating point operations. Not available for 32 bit memory models other than OSX32.
  native
    use the architecture the compiler is running on
-mcpu=[h|help|? ]
  List all architecture options
-mixin=filename
  Expand and save mixins to file specified by filename
-mv=package.module =
  Use path/filename as the source file for package.module. This is used when the source file path and names are not the same as the package and module hierarchy. The rightmost components of the path/filename and package.module can be omitted if they are the same.
-noboundscheck
  Turns off all array bounds checking, even for safe functions. Deprecated (use -boundscheck=off instead).
-O
  Optimize generated code. For fastest executables, compile with the -O -release -inline -boundscheck=off switches together.
-o-
  Suppress generation of object file. Useful in conjuction with -D or -H flags.
-od=directory
  Write object files relative to directory objdir instead of to the current directory. -op can be used if the original package hierarchy should be retained
-of=filename
  Set output file name to filename in the output directory. The output file can be an object file, executable file, or library file depending on the other switches.
-op
  Normally the path for .d source files is stripped off when generating an object, interface, or Ddoc file name. -op will leave it on.
-preview=id
  Preview an upcoming language change identified by id
-preview=[h|help|? ]
  List all upcoming language changes
-profile
  Profile runtime performance of generated code
-profile=gc
  profile the runtime performance of the generated code.
  - gc: Instrument calls to memory allocation and write a report to the file profilegc.log upon program termination.
-release
  Compile release version, which means not emitting run-time checks for contracts and asserts. Array bounds checking is not done for system and trusted functions, and assertion failures are undefined behaviour.
-revert=id
  Revert language change identified by id
-revert=[h|help|? ]
  List all revertable language changes
-run srcfile
  Compile, link, and run the program srcfile with the rest of the command line, args..., as the arguments to the program. No .o or executable file is left behind.
-shared
  Generate shared library
-transition=id
  Show additional info about language change identified by id
-transition=[h|help|? ]
  List all language changes
-unittest
  Compile in unittest code, turns on asserts, and sets the unittest version identifier
-v
  Enable verbose output for each compiler pass
-vcolumns
  Print character (column) numbers in diagnostics
-verror-style=[digitalmars|gnu ]
  Set the style for file/line number annotations on compiler messages, where:
  digitalmars
    'file(line[,column]): message'. This is the default.
  gnu
    'file:line[:column]: message', conforming to the GNU standard used by gcc and clang.
-verrors=num
  Limit the number of error messages (0 means unlimited)
-verrors=context
  Show error messages with the context of the erroring source line
-verrors=spec
  Show errors from speculative compiles such as __traits(compiles,...)
--version
  Print compiler version and exit
-version=level
  Compile in version level >= level
-version=ident
  Compile in version identifier ident
-vgc
  List all gc allocations including hidden ones
-vtls
  List all variables going into thread local storage
-w
  Enable warnings
-wi
  Enable informational warnings (i.e. compilation still proceeds normally)
-X
  Generate JSON file
-Xf=filename
  Write JSON file to filename
-Xcc=driverflag
  Pass driverflag to the linker driver ($CC or cc)

## Files

dmd2/src/phobos/
  D runtime library source
dmd2/src/dmd/
  D compiler front end source under dual (GPL and Artistic) license
dmd2/html/d/
  Documentation
dmd2/samples/d/
  Sample D programs
dmd2/osx/bin/ddemangle
  D symbol demangler
dmd2/osx/bin/dman
  D manual lookup tool
dmd2/osx/bin/dmd
  D compiler executable
dmd2/osx/bin/dmd.conf
  Global compiler settings (copy to /etc/dmd.conf)
dmd2/osx/bin/dub
  D's package manager
dmd2/osx/bin/dumpobj
  Mach-O file dumper
dmd2/osx/bin/dustmite
  D source code minimizer
dmd2/osx/bin/obj2asm
  Mach-O file disassembler
dmd2/osx/bin/rdmd
  D build tool for script-like D code execution
dmd2/osx/bin/shell
  Simple command line shell
dmd2/osx/lib/libphobos2.a
  D runtime library (copy to /usr/local/lib/libphobos2.a)

## Linking

Linking is done directly by the dmd compiler after a successful compile. To prevent dmd from running the linker, use the -c switch.

The actual linking is done by running gcc. This ensures compatibility with modules compiled with gcc.

## Environment Variables

The D compiler dmd uses the following environment variables:

CC
  dmd normally runs the linker by looking for gcc along the PATH. To use a specific linker instead, set the CC environment variable to it. For example:

    set CC=gcc

BROWSER
  This sets the browser used to open the manual page with the -man switch. It defaults to x-www-browser.
DFLAGS
  The value of DFLAGS is treated as if it were appended to the command line to dmd.

## dmd.conf Initialization File

The dmd file dmd.conf is the same as sc.ini for Windows, it's just that the file has a different name, enabling a setup common to both Windows and this system to be created without having to re-edit the file.

dmd will look for the initialization file dmd.conf in the following sequence of directories:

1. current working directory
2. directory specified by the HOME environment variable
3. directory dmd resides in
4. /etc/

If found, environment variable settings in the file will override any existing settings. This is handy to make dmd independent of programs with conflicting use of environment variables.

Environment variables follow the [Environment] section heading, in NAME=value pairs. The NAMEs are treated as upper case. Comments are lines that start with ;. For example:

    ; dmd.conf file for dmd
    ; Names enclosed by %% are searched for in the existing environment
    ; and inserted. The special name %@P% is replaced with the path
    ; to this file.
    [Environment]

    DFLAGS=-I%@P%/../src/phobos -I%@P%/../src/druntime/import

## Differences between Windows and Linux versions

- String literals are read-only under Linux. Attempting to write to them will cause a segment violation.

## D Interface Files

When an import declaration is processed in a D source file, the compiler searches for the D source file corresponding to the import, and processes that source file to extract the information needed from it. Alternatively, the compiler can instead look for a corresponding D interface file. A D interface file contains only what an import of the module needs, rather than the whole implementation of that module.

The advantages of using a D interface file for imports rather than a D source file are:

- D interface files are often significantly smaller and much faster to process than the corresponding D source file.
- They can be used to hide the source code, for example, one can ship an object code library along with D interface files rather than the complete source code.

D interface files can be created by the compiler from a D source file by using the -H switch to the compiler. D interface files have the .di file extension. When the compiler resolves an import declaration, it first looks for a .di D interface file, then it looks for a D source file.

D interface files bear some analogous similarities to C++ header files. But they are not required in the way that C++ header files are, and they are not part of the D language. They are a feature of the compiler, and serve only as an optimization of the build process.

## Building Executables

dmd can build an executable much faster if as many of the source files as possible are put on the command line.

Another advantage to putting multiple source files on the same invocation of dmd is that dmd will be able to do some level of cross-module optimizations, such as function inlining across modules.

The -i flag can be used to automatically compile imported modules

## Building Libraries

There are three ways to build a library. For example, given foo.d and bar.d which are to be compiled, and existing object file abc.o and existing library def.a which are all to be combined into a library foo.a:

1. Compile modules separately and then run the librarian on them:

       dmd -c foo.d
       dmd -c bar.d
       rm -f foo.a
       ar -r foo.a foo.o bar.o abc.o def.a
       rm foo.o bar.o

   This option is typical when using a makefile to avoid compiling modules that have already been compiled.
2. Compile modules together and then run the librarian on them:

       dmd -c foo.d bar.d
       rm -f foo.a
       ar -r foo.a foo.o bar.o abc.o def.a
       rm foo.o bar.o

3. Use dmd to compile and build library in one operation:

       dmd -lib foo.d bar.d abc.o def.a

   No object files are written to disk, it's all done in memory. Using -lib also has the advantage that modules may be compiled into multiple object files rather than exactly one per module. This improves granularity of the library without having to break up the modules.

## Compiling dmd

Complete source code is provided to build the compiler. Follow these steps:

    cd ~/dmd2/src/dmd
    make -f posix.mak

## Compiling Phobos

Complete source code is provided to build Phobos, the D runtime library. Follow these steps:

    cd ../phobos
    make -f posix.mak

Copyright © 1999-2020 by the D Language Foundation | Page generated by Ddoc on Mon Mar 9 06:16:59 2020